Index: /branches/PerformanceComparison/HeuristicLab.Analysis.Views/3.3/IndexedDataTableView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Analysis.Views/3.3/IndexedDataTableView.cs	(revision 12821)
+++ /branches/PerformanceComparison/HeuristicLab.Analysis.Views/3.3/IndexedDataTableView.cs	(revision 12822)
@@ -55,4 +55,5 @@
       chart.CustomizeAllChartAreas();
       chart.ChartAreas[0].CursorX.Interval = 1;
+      chart.SuppressExceptions = true;
     }
 
@@ -246,16 +247,16 @@
         a.Maximum = double.NaN;
       }
-      // chart controls handle log scaling problems not in a graceful way
-      if (chart.Series.Any(x => x.XAxisType == AxisType.Primary && (x.Points.Count == 0 || x.Points.Any(y => y.XValue <= 0))))
+
+      if (chart.Series.Any(x => x.Enabled && x.XAxisType == AxisType.Primary && (x.Points.Count == 0 || x.Points.Any(y => y.XValue <= 0))))
         area.AxisX.IsLogarithmic = false;
       else area.AxisX.IsLogarithmic = Content.VisualProperties.XAxisLogScale;
-      if (chart.Series.Any(x => x.XAxisType == AxisType.Secondary && (x.Points.Count == 0 || x.Points.Any(y => y.XValue <= 0))))
+      if (chart.Series.Any(x => x.Enabled && x.XAxisType == AxisType.Secondary && (x.Points.Count == 0 || x.Points.Any(y => y.XValue <= 0))))
         area.AxisX2.IsLogarithmic = false;
       else area.AxisX2.IsLogarithmic = Content.VisualProperties.SecondXAxisLogScale;
 
-      if (chart.Series.Any(x => x.YAxisType == AxisType.Primary && (x.Points.Count == 0 || x.Points.Any(y => y.YValues.Min() <= 0))))
+      if (chart.Series.Any(x => x.Enabled && x.YAxisType == AxisType.Primary && (x.Points.Count == 0 || x.Points.Any(y => y.YValues.Min() <= 0))))
         area.AxisY.IsLogarithmic = false;
       else area.AxisY.IsLogarithmic = Content.VisualProperties.YAxisLogScale;
-      if (chart.Series.Any(x => x.YAxisType == AxisType.Secondary && (x.Points.Count == 0 || x.Points.Any(y => y.YValues.Min() <= 0))))
+      if (chart.Series.Any(x => x.Enabled && x.YAxisType == AxisType.Secondary && (x.Points.Count == 0 || x.Points.Any(y => y.YValues.Min() <= 0))))
         area.AxisY2.IsLogarithmic = false;
       else area.AxisY2.IsLogarithmic = Content.VisualProperties.SecondYAxisLogScale;
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs	(revision 12821)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs	(revision 12822)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.ComponentModel;
+using System.Drawing;
 using System.Linq;
 using System.Windows.Forms;
@@ -37,4 +38,19 @@
   public partial class RunCollectionRLDView : ItemView {
     private const string AllRuns = "All Runs";
+
+    private static readonly Color[] colors = new[] {
+      Color.FromArgb(0x20, 0x4A, 0x87),
+      Color.FromArgb(0xC1, 0x7D, 0x11),
+      Color.FromArgb(0x4E, 0x9A, 0x06),
+      Color.FromArgb(0x75, 0x50, 0x7B),
+      Color.FromArgb(0x72, 0x9F, 0xCF),
+      Color.FromArgb(0xA4, 0x00, 0x00),
+      Color.FromArgb(0xAD, 0x7F, 0xA8),
+      Color.FromArgb(0xF5, 0x79, 0x00),
+      Color.FromArgb(0x55, 0x57, 0x53),
+      Color.FromArgb(0xEF, 0x29, 0x29),
+      Color.FromArgb(0xED, 0xD4, 0x00),
+      Color.FromArgb(0x73, 0xD2, 0x16),
+    };
 
     public new RunCollection Content {
@@ -208,4 +224,12 @@
                             select Tuple.Create(g.Key, g.ToList())).ToList();
         var xAxisTitles = new HashSet<string>();
+        var colorCount = 0;
+        var lineStyles = new[] {
+          DataRowVisualProperties.DataRowLineStyle.Solid,
+          DataRowVisualProperties.DataRowLineStyle.Dash,
+          DataRowVisualProperties.DataRowLineStyle.DashDot,
+          DataRowVisualProperties.DataRowLineStyle.Dot
+        };
+        var lineStyleCount = 0;
         foreach (var group in groupedRuns) {
           var hits = new Dictionary<string, SortedList<double, double>>();
@@ -258,5 +282,7 @@
               VisualProperties = {
                 ChartType = DataRowVisualProperties.DataRowChartType.StepLine,
-                LineWidth = 2
+                LineWidth = 2,
+                Color = colors[colorCount],
+                LineStyle = lineStyles[lineStyleCount]
               }
             };
@@ -268,4 +294,6 @@
             combinedDataTable.Rows.Add(row);
           }
+          colorCount = (colorCount + 1) % colors.Length;
+          if (colorCount == 0) lineStyleCount = (lineStyleCount + 1) % lineStyles.Length;
         }
         combinedDataTable.VisualProperties.XAxisTitle = string.Join(" / ", xAxisTitles);